package com.jrx.authtication;

import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import java.net.URL;
import java.security.KeyManagementException;
import java.security.NoSuchAlgorithmException;
import java.security.SecureRandom;
import java.security.cert.CertificateException;
import java.security.cert.X509Certificate;
import javax.net.ssl.HostnameVerifier;
import javax.net.ssl.HttpsURLConnection;
import javax.net.ssl.KeyManager;
import javax.net.ssl.SSLContext;
import javax.net.ssl.SSLSession;
import javax.net.ssl.SSLSocketFactory;
import javax.net.ssl.TrustManager;
import javax.net.ssl.X509TrustManager;

public class HttpsClient {

   private static String result;
   private static String GET = "GET";
   private static String POST = "POST";
   private static String TLS = "TLS";


   public static void main(String[] args) throws IOException {
      String uri = "https://www.baidu.com";
      String bytes = doGet(uri);
      System.out.println(bytes);
   }

   public static String doGet(String uri) throws IOException {
      HttpsURLConnection httpsConn = getHttpsURLConnection(uri, GET);
      return getBytesFromStream(httpsConn.getInputStream());
   }

   public static String doPost(String uri, String data) throws IOException {
      HttpsURLConnection httpsConn = getHttpsURLConnection(uri, POST);
      setBytesToStream(httpsConn.getOutputStream(), data.getBytes());
      return getBytesFromStream(httpsConn.getInputStream());
   }

   private static HttpsURLConnection getHttpsURLConnection(String uri, String method) throws IOException {
      SSLContext ctx = null;

      try {
         ctx = SSLContext.getInstance(TLS);
         ctx.init(new KeyManager[0], new TrustManager[]{new HttpsClient.DefaultTrustManager((HttpsClient.DefaultTrustManager)null)}, new SecureRandom());
      } catch (KeyManagementException var6) {
         var6.printStackTrace();
      } catch (NoSuchAlgorithmException var7) {
         var7.printStackTrace();
      }

      SSLSocketFactory ssf = ctx.getSocketFactory();
      URL url = new URL(uri);
      HttpsURLConnection httpsConn = (HttpsURLConnection)url.openConnection();
      httpsConn.setSSLSocketFactory(ssf);
      httpsConn.setHostnameVerifier(new HostnameVerifier() {
         public boolean verify(String arg0, SSLSession arg1) {
            return true;
         }
      });
      httpsConn.setRequestMethod(method);
      httpsConn.setDoInput(true);
      httpsConn.setDoOutput(true);
      return httpsConn;
   }

   private static void setBytesToStream(OutputStream os, byte[] bytes) throws IOException {
      ByteArrayInputStream bais = new ByteArrayInputStream(bytes);
      byte[] kb = new byte[1024];

      try {
         int len;
         while((len = bais.read(kb)) != -1) {
            os.write(kb, 0, len);
         }

         os.flush();
      } catch (IOException var8) {
         var8.printStackTrace();
      }

      try {
         if(os != null) {
            os.close();
         }
      } catch (IOException var7) {
         var7.printStackTrace();
      }

      try {
         if(bais != null) {
            bais.close();
         }
      } catch (IOException var6) {
         var6.printStackTrace();
      }

   }

   private static String getBytesFromStream(InputStream is) throws IOException {
      ByteArrayOutputStream baos = new ByteArrayOutputStream();
      byte[] kb = new byte[1024];

      try {
         int len;
         while((len = is.read(kb)) != -1) {
            baos.write(kb, 0, len);
         }

         baos.flush();
      } catch (IOException var7) {
         var7.printStackTrace();
      }

      try {
         if(baos != null) {
            baos.close();
         }
      } catch (IOException var6) {
         var6.printStackTrace();
      }

      try {
         if(is != null) {
            is.close();
         }
      } catch (IOException var5) {
         var5.printStackTrace();
      }

      result = new String(baos.toByteArray());
      return result;
   }

   private static final class DefaultTrustManager implements X509TrustManager {

      private DefaultTrustManager() {
      }

      public void checkClientTrusted(X509Certificate[] chain, String authType) throws CertificateException {
      }

      public void checkServerTrusted(X509Certificate[] chain, String authType) throws CertificateException {
      }

      public X509Certificate[] getAcceptedIssuers() {
         return null;
      }

      // $FF: synthetic method
      DefaultTrustManager(HttpsClient.DefaultTrustManager var1) {
         this();
      }
   }
}
